---
layout: page
title: Rules
---
<!--
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
-->

<!-- TODO link to jira when we have an apache jira. -->

We are always very happy to have code contributions whether for trivial cleanups or big new features. In general, patches should include:

* Code change
* Unit tests
* Javadocs
* Metrics
* Logging

To submit a patch for inclusion please do the following:

* If you are working on a big new feature ([project](projects.html)), follow the steps outlined on the [design documents](/contribute/design-documents.html) page.
* Create a patch that applies cleanly against trunk.
* Make sure you have observed the recommendations in the style guide.
* Open a [JIRA](https://issues.apache.org/jira/browse/SAMZA) ticket describing the patch and attach your patch to the JIRA.
* Open a [Review Board](https://reviews.apache.org/groups/samza/) ticket with your patch attached.
* Post a link to the RB code review on the JIRA ticket.
* Nag us if we don't follow up on your JIRA in a timely fashion.
